#!/usr/bin/perl

#############################################################
# Ikonboard v2.1
# Copyright 2000 Ikondiscussion.com - All Rights Reserved
# Ikondiscussion is a trademark of Ikondiscussion.com
#
# Software Distributed by: Ikondiscussion.com
# Visit us online at http://www.ikondiscussion.com
# Email us on boards@ikondiscussion.com
#
# All files written by Matthew Mecham
#
# Memberlist, origial concept an script by skeptiker
# version 2.5+ by Holger Ronecker (ikonboard@ronecker.com)
#
$memberlistversion = "v2.53"; 
#############################################################

use CGI::Carp "fatalsToBrowser";          # Output errors to browser
use CGI qw(:standard);                    # Saves loads of work
$CGI::HEADERS_ONCE = 1; 

######### Configuration

$topanzahl = 20;               # Top XX Poster 
$startseite = "1";             # order by: 1->number of posts, 2->TopTen, 3->name,
                               #    4->date, 5->who is online, 6->first letter
$memberproseite = 20;          # number of members per page
$customtitle = 0; 			   # show custom member title instead of normal title?
                               #    1->yes, 0->no 
$timeonline = 15;			   # time (in minutes) after which a visitor is offline 

# select your language, take out the '#' in front of the choosen language
# $languagefile = "$ikondir" . "memberlist.de"; # german / deutsch
# $languagefile = "$ikondir" . "memberlist.en"; # english
# $languagefile = "$ikondir" . "memberlist.sw"; # swedish
######### don't change anything below

eval {
($0 =~ m,(.*)/[^/]+,)   and unshift (@INC, "$1");
($0 =~ m,(.*)\\[^\\]+,) and unshift (@INC, "$1");
require "ikon.lib";
require "data/boardinfo.cgi";
require "data/boardstats.cgi";
require "data/progs.cgi";
require "data/styles.cgi";
require "data/membertitles.cgi";
#require "$languagefile";
};
if ($@) {
    print header(); print start_html(-title=>"$ibtxt{'0025'}");
    print "$ibtxt{'0026'} $@\n$ibtxt{'0027'}";
    print end_html; exit;
}
$|++;                                     # Unbuffer the output
#################--- Begin the program ---###################

### read and save memberfiles

$thisprog = "memberlist.cgi";

$inmembername = cookie("amembernamecookie");
$inpassword   = cookie("apasswordcookie");

if ($inmembername eq "") {
  $inmembername = "$ibtxt{'0043'}";
}

&whosonline("$inmembername|$ibtxt{'5901'}|$ibtxt{'0016'}");

&title;

chdir("$ikondir" . "members") || die "$ibtxt{'5902'}";
$memberdir = "$ikondir/members"; 
opendir (MEMBERDIR, "$memberdir" ) || die "$ibtxt{'5902'}"; 
@memberfiles = readdir (MEMBERDIR); 
closedir (MEMBERDIR); 
@cgi = grep (/\.cgi/, @memberfiles);

### header

$output .= qq~<table cellpadding=0 cellspacing=0 border=0 width=$tablewidth align=center>
<tr>
    <td width=30% rowspan=2><img src="$imagesurl/images/$boardlogo" border=0></td>
    <td valign=middle align=left><font face="$font" color=$fontcolormisc size=2>
      &nbsp;&nbsp;<img src="$imagesurl/images/closedfold.gif" border=0><a href="$forumsummaryprog">&nbsp;&nbsp;$boardname</a><br>
	  &nbsp;&nbsp;<img src="$imagesurl/images/bar.gif" border=0><img src="$imagesurl/images/openfold.gif" border=0>&nbsp;&nbsp;$ibtxt{'5901'}</font>
    </td>
</tr><tr>
    <td valign=bottom align=right>&nbsp; $helpurl</td>
</tr>
</table><br>~;

$output .= qq~<html><body bgcolor=$backgroundcolor text=$forumfontcolor link=$forumfontcolor vlink=$forumfontcolor alink=$forumfontcolor>
<!--Javascript-->
    <script type="text/javascript">
        function openScript(url, width, height) {
            var Win = window.open(url,"openScript",'width=' + width + ',height=' + height +      ',resizable=1,scrollbars=yes,menubar=yes,status=yes' );
        }
    </script>~;


### who is online list

sub Weristonline {
    $query = new CGI;
    
    $inpage = $query -> param ("page");
    if ($inpage eq "") { $inpage = 1; }
    $a = 5;

    $filetoopen = "$ikondir" . "data/onlinedata.dat";
    open(FILE,"$filetoopen");
    @onlinedata = <FILE>;
    close(FILE);
	
	foreach $line (@onlinedata) {
#        chomp $line;
    	($savedusername, $trash) = split(/\|/, $line);
    	if (!($savedusername =~ m/^$ibtxt{'0043'}/s)) {
            push (@memberarray,$savedusername); }
    }
	@memberarray = sort alphabetically @memberarray;
    foreach $cginame (@memberarray) { $cginame .='.cgi'; }

	&splitting;
	$Listenname = "$ibtxt{'5906'}$ibtxt{'5932'}";
	&Tabellenanfang;

    foreach $member (@memberarray[$startmember ... $endmember]) {
        $member =~s/ /_/g;
    	$member1 = ucfirst($member);
		if ("$member" || "$member1") {
      	    $filetoopen = ("$ikondir" . "members/$member") || ("$ikondir" . "members/$member1");
      		open(FILE, "$filetoopen" );
      		$memberdaten = <FILE>;
      		close(FILE);
      		&Listing;
	    }
    }
    $output .= qq~</table>~;
}


### order by membername

sub Namensortiert {
	@cgi = sort alphabetically @cgi;

    $query = new CGI;
    $inpage = $query -> param ("page");
    if ($inpage eq "") { $inpage = 1; }
    $a = 3;
    
	@memberarray = @cgi;
	&splitting;
	$Listenname = "$ibtxt{'5906'}$ibtxt{'5903'}";
	&Tabellenanfang;
	
    foreach $member (@cgi[$startmember ... $endmember]) { 
        $member1 = ucfirst($member);
		if ("$member" || "$member1") {
      	    $filetoopen = ("$ikondir" . "members/$member") || ("$ikondir" . "members/$member1");
      		open(FILE, "$filetoopen" );
      		$memberdaten = <FILE>;
      		close(FILE);
      		&Listing;
	    }
  	}
    $output .= qq~</table>~;
}


### order by number of postings

sub Postsortiert {
	foreach $member (@cgi) {
        $member1 = ucfirst($member);
    	$filetoopen = ("$ikondir" . "members/$member") || ("$ikondir" . "members/$member1");
    	open(FILE, "$filetoopen" );
    	$memberdaten = <FILE>;
    	close(FILE);
    	
    	@memberdaten = split(/\|/,$memberdaten);
    	$name = $memberdaten[0];
    	$anzahl = $memberdaten[4];
    	$postundmember {"$name"} = $anzahl;
    	@sortiert = reverse sort { $postundmember{$a} <=> $postundmember{$b} } keys(%postundmember);
	}

    $query = new CGI;
    
    $inpage = $query -> param ("page");
    if ($inpage eq "") {$inpage = 1;}
    $a = 1;
    
    $Listenname = "$ibtxt{'5906'}$ibtxt{'5904'}";
    &Tabellenanfang;
    
    foreach $cginame (@sortiert) { $cginame .='.cgi'; }
    @memberarray = @sortiert;
    &splitting;
    foreach $member (@sortiert[$startmember ... $endmember]) {
        $member =~s/ /_/g;
    	$member1 = ucfirst($member);
		if ("$member" || "$member1") {
      	    $filetoopen = ("$ikondir" . "members/$member") || ("$ikondir" . "members/$member1");
      		open(FILE, "$filetoopen" );
      		$memberdaten = <FILE>;
      		close(FILE);
      		&Listing;
	    }
    }
    $output .= qq~</table>~;
}


### show TopXX poster

sub Topten {
	foreach $member (@cgi) {
        $member1 = ucfirst($member);
    	$filetoopen = ("$ikondir" . "members/$member") || ("$ikondir" . "members/$member1");
    	open(FILE, "$filetoopen" );
    	$memberdaten = <FILE>;
    	close(FILE);
    	
    	@memberdaten = split(/\|/,$memberdaten);
    	$name = $memberdaten[0];
    	$anzahl = $memberdaten[4];
    	$postundmember {"$name"} = $anzahl;
        @sortiert = reverse sort { $postundmember{$a} <=> $postundmember{$b} } keys(%postundmember);
	}

    $Listenname = "$ibtxt{'5906'}$ibtxt{'5905'}$topanzahl$ibtxt $ibtxt{'5911'}";
	&splitting;
	&Tabellenanfang;
	
	foreach $cginame (@sortiert) { $cginame .='.cgi'; }
	@sortiert = splice(@sortiert,0,$topanzahl);
	foreach $member (@sortiert) {
        $member =~s/ /_/g;
        $member1 = ucfirst($member);
        $filetoopen = ("$ikondir" . "members/$member") || ("$ikondir" . "members/$member1");
        open(FILE, "$filetoopen" );
        $memberdaten = <FILE>;
        close(FILE);
        &Listing;
    }
	$output .= qq~</table>~;
}


### order by date of registration 

sub datum {
	foreach $member (@cgi) {
        $member1 = ucfirst($member);
    	$filetoopen = ("$ikondir" . "members/$member") || ("$ikondir" . "members/$member1");
    	open(FILE, "$filetoopen" );
    	$memberdaten = <FILE>;
    	close(FILE);
    	
    	@memberdaten = split(/\|/,$memberdaten);
    	$name = $memberdaten[0];
    	$date1 = $memberdaten[13] + ($memberdaten[16] * 3600) + ($timezone * 3600);
    	$datumundmember {"$name"} = $date1;
        @sortiert1 = sort { $datumundmember{$a} <=> $datumundmember{$b} } keys(%datumundmember);
	}

    $query = new CGI;
	
	$inpage = $query -> param ("page");
	if ($inpage eq "") { $inpage = 1; }
	$a = 4;
	$Listenname = "$ibtxt{'5906'}$ibtxt{'5907'}";
	&Tabellenanfang;
	
	foreach $cginame (@sortiert1) { $cginame .='.cgi'; }
	@memberarray = @sortiert1;
	&splitting;
	
	foreach $member (@sortiert1[$startmember ... $endmember]) {
        $member =~s/ /_/g;
        $member1 = ucfirst($member);
		if ("$member" || "$member1") {
            $filetoopen = ("$ikondir" . "members/$member") || ("$ikondir" . "members/$member1");
        	open(FILE, "$filetoopen" );
        	$memberdaten = <FILE>;
        	close(FILE);
        	&Listing;
	    }
    }
	$output .= qq~</table>~;
}

### show member by their first letter

sub alphasort {
    $query = new CGI;
    
    $a = 6;
	$inpage = $query -> param ("page");
    $alpha = $query->param('N');
    if ($inpage eq "") { $inpage = 1; }
	if ($alpha eq "") { $alpha = "A"; }
    $alpha1 = lc($alpha);
    
	$Listenname = "$ibtxt{'5906'}$ibtxt{'5933'} $alpha";
	&Tabellenanfang;
    foreach $cginame (@cgi) {
      if($cginame =~ m/^$alpha/s || $cginame =~ m/^$alpha1/s )  { push (@memberarray,$cginame); }
    }
	@memberarray = sort alphabetically @memberarray;

    &splitting;
    foreach $member (@memberarray[$startmember ... $endmember]) {
    	$member =~s/ /_/g;
    	$member1 = ucfirst($member);
        if ("$member" || "$member1") {
           $filetoopen = ("$ikondir" . "members/$member") || ("$ikondir" . "members/$member1");
           open(FILE, "$filetoopen" );
           $memberdaten = <FILE>;
           close(FILE);
           &Listing;
           }
    }
    $output .= qq~</table>~;
}

### start of table (the part above all members)

sub Tabellenanfang {
    $output .= qq~<center>
<table width=$tablewidth cellspacing=0 border=1 bordercolor=$tablebordercolor>
<tr bgcolor=$titleback>
	<td colspan=7 valign=top>
	    <p><font face=$font size=3><b>&nbsp;&nbsp;$Listenname</b></font></p>
		<font face=$font size=1><b>&nbsp;&nbsp;$ibtxt{'5908'}</b> $totalmembers $ibtxt{'5909'}
		$totalposts	$ibtxt{'5910'}</font>
	</td>
	<td colspan=5 align=right><form method=POST action="$thisprog">
		<input type=submit value="$ibtxt{'5912'}">&nbsp;&nbsp;&nbsp;

    	<select name=a>
        <option value=2>$ibtxt{'5905'}$topanzahl $ibtxt{'5911'}</option>
        <option value=3>$ibtxt{'5903'}</option>
        <option value=1>$ibtxt{'5910'}</option>
        <option value=4>$ibtxt{'5907'}</option>
        <option value=5>$ibtxt{'5932'}</option>
        <option value=6>$ibtxt{'5933'}</option>
        </select>&nbsp;&nbsp;&nbsp;
		
        </form>
	</td></tr>~;
	
	if ($a == 6) {
        foreach (@cgi) {
            $fr = substr($_, 0, 1);
        	$fr =~ tr/a-z/A-Z/;
        	push(@letters,$fr);
        	}

    	@sortedletters = sort(@letters);
    	foreach (@sortedletters) {
        	unless ($_ eq "$ltr") {
            	if ($alpha eq $_) { $tempoutput .= qq~&nbsp;<b>$_</b>&nbsp;~; }
				else { $tempoutput .= qq~<a href="$thisprog?a=6&N=$_">&nbsp;$_&nbsp;</a>~; }
            	$ltr = "$_";
            	}
        	}
	
		$output .= qq~<tr bgcolor=$titleback><td colspan='12' align='center'><font face=$font size=2>$tempoutput</font></td></tr>~;
		}
			   
$output .= qq~<tr bgcolor=$titlecolor>
    <td width=10%><font face=$font size=2>&nbsp;$ibtxt{'5913'}</td>
	<td width=5% align=center><font face=$font size=2>$ibtxt{'5914'}</td>
	<td width=5% align=center><font face=$font size=2>$ibtxt{'5930'}</td>
	<td width=10% align=center><font face=$font size=2>$ibtxt{'5915'}</td>
	<td width=10% align=center><font face=$font size=2>$ibtxt{'5916'}</td>
	<td width=10% align=center><font face=$font size=2>$ibtxt{'5917'}</td>
	<td width=10% align=center><font face=$font size=2>$ibtxt{'5918'}</td>
	<td width=10% align=center><font face=$font size=2>$ibtxt{'5919'}</td>
	<td width=10% align=center><font face=$font size=2>$ibtxt{'5920'}</td>
	<td width=10% align=center><font face=$font size=2>$ibtxt{'5921'}</td>
	<td width=10% align=center><font face=$font size=2>&nbsp;&nbsp;$ibtxt{'5922'}&nbsp;&nbsp;</td>
	<td width=10% align=center><font face=$font size=2>$ibtxt{'5923'}</td></font></tr>~;
}


read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
$query = new CGI;
$a = $query -> param ("a");
if ($a eq '' && $buffer eq '') { $buffer = "a=$startseite"; }
else { ($buffer = "$buffer") || ($buffer = "a=$a"); }


if ($buffer eq 'a=1') { &Postsortiert }
elsif ($buffer eq 'a=2') { &Topten }
elsif ($buffer eq 'a=3') { &Namensortiert }
elsif ($buffer eq 'a=4') { &datum }
elsif ($buffer eq 'a=5') { &Weristonline }
elsif ($buffer eq 'a=6') { &alphasort }


### print one member

sub Listing {
	@memberdaten = split(/\|/,$memberdaten);
	$name = $memberdaten[0];
	$status = $memberdaten[2];
	$anzahl = $memberdaten[4];
	$email = $memberdaten[5];
	$home = $memberdaten[8];
	$aolname = $memberdaten[9];
	$icq = $memberdaten[10];
	$date = $memberdaten[13] + ($memberdaten[16] * 3600) + ($timezone * 3600);
	$date = &longdate("$date");
	$rang = $memberdaten[3];
	$emailstatus = $memberdaten[6];
	$useravatar = $memberdaten[18];
	($postdate, $posturl, $posttopic) = split(/\%%%/, $memberdaten[14]);
	
    $name =~ s/\_/ /g;

	if ($postdate ne "$ibtxt{'1816'}") {
        $postdate = $postdate + ($userdetail[16] * 3600) + ($timezone * 3600);
        $lastposttime = &longdate ("$postdate");
        $lastpostdetails = qq~<a href="$posturl"><img border=0 src=$imagesurl/images/openfold.gif alt='"$posttopic" $ibtxt{'5929'} $lastposttime'></a>~;
		if ($posturl eq "" && $anzahl > 0) { $lastpostdetails = qq~<img border=0 src=$imagesurl/images/closedfold.gif alt="$ibtxt{'5931'}">~; }
	}
	else { $lastpostdetails = qq~<img border=0 src=$imagesurl/images/closedfold.gif alt="$ibtxt{'1816'}">~; }

	$postundmember {"$name"} = $anzahl;
	
	if (($icq) && ($icq =~ /[0-9]/)){
        $icqgraphic = qq~<a href="javascript:openScript('$miscprog?action=icq&UIN=$icq',450,300)"><img src="http://wwp.icq.com/scripts/online.dll?icq=$icq&img=5" border=0></a>~;
    }
	else { $icqgraphic = "$ibtxt{'5924'}"; }
	
	if ($home eq "http://"){ $home = "$ibtxt{'5924'}"; }
	else {
       $home = "<a href=$home target=_blank><img border=0 src=$imagesurl/images/homepage.gif></a>"
    }
	
	if ($aolname){
       $aolgraphic = qq~<a href="javascript:openScript('$miscprog?action=aim&aimname=$aolname',450,200)"><img src="$imagesurl/images/aol.gif" border=0></a>~;
    }
	else { $aolgraphic = "$ibtxt{'5924'}"; }
	
	if ($email eq "" || $emailstatus eq "no") { $email = "$ibtxt{'5924'}"; }
	else { $email = "<a href=mailto:$email><img border=0 src=$imagesurl/images/email.gif></a>" }
	
    if ($anzahl > $mpostmark5) { $mtitle = "$mtitle5"; $membergraphic = "$mgraphic5"; }
	elsif ($anzahl > $mpostmark4) { $mtitle = "$mtitle4"; $membergraphic = "$mgraphic4"; }
	elsif ($anzahl > $mpostmark3) { $mtitle = "$mtitle3"; $membergraphic = "$mgraphic3"; }
	elsif ($anzahl > $mpostmark2) { $mtitle = "$mtitle2";  $membergraphic = "$mgraphic2"; }
	else { $mtitle = "$mtitle1"; $membergraphic = "$mgraphic1"; }

    if ($rang eq "ad") { $posterfontcolor = "$adminnamecolor";
	   		  	 	     if (($customtitle == 1) && ($status ne "$ibtxt{'1874'}")) { $mtitle = "<i>$status</i>"; }
						 else { $mtitle = "&nbsp;<i>$ibtxt{'1874'}</i>&nbsp;"; }
						 $membergraphic = "$admingraphic";
						 $outname = "$name&nbsp;<img src=\"$imagesurl/images/team.gif\" border=0>"; }
    elsif ($rang eq "mo") { $posterfontcolor = "$teamnamecolor";
	   		  	 	        if (($customtitle == 1) && ($status ne "$ibtxt{'0007'}")) { $mtitle = "<i>$status</i>"; }
						    else { $mtitle = "&nbsp;<i>$ibtxt{'0007'}</i>&nbsp;"; }
						    $outname = "$name&nbsp;<img src=\"$imagesurl/images/team.gif\" border=0>"; }
	elsif ($rang eq "me") { if (($customtitle == 1) && ($status ne "$ibtxt{'0136'}")) { $mtitle = "$status"; }
		  		 		  	$posterfontcolor = "$posternamecolor"; 
		   					$outname = $name;}
	else { $posterfontcolor = "$posternamecolor"; 
		   $outname = $name; }
	
    if ($membergraphic) { $membergraphic = "<img src=\"$imagesurl/images/$membergraphic\" border=\"0\">"; }

	$message = "<a href=\"javascript:openScript('messenger.cgi?action=new&touser=$name',600,400)\"><img src=$imagesurl/images/message.gif border=0></a>";
	
            $memberfilename = $name;
    $memberfilename =~ y/ /_/;

 if (($avatars eq "on") && ($useravatar) && ($useravatar ne "noavatar")) {
        if ($useravatar eq "personal_avatar") {
            $useravatar = "$imagesurl/avatars/personal/$memberfilename.gif";
        }
        elsif ($useravatar !~ /^http:\/\//) {
            $useravatar = "$imagesurl/avatars/$useravatar.gif";
        }

        $useravatar = qq(<br><img src="$useravatar" border=0 width="64" height="64">);
    }
    else {
        undef $useravatar;
    }

	
	#online ?
	$filetoopen = "$ikondir" . "data/onlinedata.dat";
    open(FILE,"$filetoopen");
    @onlinedata = <FILE>;
    close(FILE);

	$ende = "nein";
    foreach $line (@onlinedata) {
        chomp $line;
    	($savedusername, $savedtime, $savedwhere) = split(/\|/, $line);
    	$savedtime = $savedtime + ($timezone*3600) + ($timedifferencevalue*3600);
		$timecompare = $savedtime + $timeonline * 60;
		$currenttime = time;
    	$longdate = &longdate("$savedtime");
    	$shorttime = &shorttime("$savedtime");
    	$savedtime = "$longdate - $shorttime";
    	$lookfor = substr($savedusername, 0, 5);
    	if ($lookfor eq "$ibtxt{'0043'}") { $savedusername = "$ibtxt{'0043'}"; }
		
		if ($ende eq "nein") {
    	    if (($savedusername eq $name) && ($timecompare > $currenttime)) {
		        $onlinepic = "<img src=\"$imagesurl/images/mem_on.gif\" border=0 alt=\"$ibtxt{'5927'}, $savedtime\";>";
				$ende = "ja";
	        } else {
			    $onlinepic = "<img src=\"$imagesurl/images/mem_off.gif\" border=0 alt=\"$ibtxt{'5928'}\">";
            }
		}
	}
	
	
	$output .= qq~<tr bgcolor=$forumcolortwo>
	<td><font face=$font color=$posterfontcolor size=2>&nbsp;$outname</font></td>
	<td align=center><font face=$font size=1>$useravatar</font></td>
	<td align=center><font face=$font size=1>$onlinepic</font></td>
	<td align=center><font face=$font size=1>$email</font></td>
	<td align=center><font face=$font size=1>$icqgraphic</font></td>
	<td align=center><font face=$font size=1>$aolgraphic</font></td>
	<td align=center><font face=$font size=1>$home</font></td>
	<td align=center>$message</td>
	<td align=center><font face=$font size=1>$lastpostdetails</font></td>
	<td align=center><font face=$font size=1>$date</font></td>
	<td align=center><font face=$font color=$posterfontcolor size=2>$mtitle<br>$membergraphic</font></td>
	<td align=center><font face=$font size=2>$anzahl</font></td></tr>~;
}


### split into several pages

sub splitting {
    $totalpages = @memberarray / $memberproseite;
	($pagenumbers, $decimal) = split (/\./, $totalpages);
	if ($decimal > 0) { $pagenumbers++; }
	$page = 1;
	$pagedigit = 0;
	
	$pagelinks = qq~$ibtxt{'5925'} ~;
	while ($pagenumbers > $pagedigit) {
	    $pagedigit++;
		if ($inpage ne $page) {
		    $pagelinks .= qq~[<a href="$boardurl/memberlist.cgi?a=$a&page=$page">$pagedigit</a>] ~;
		}
		else { $pagelinks .= qq~[$pagedigit] ~; }
		$page++;
	}
	
	if ($totalpages <= 1) { $pagelinks = qq~$ibtxt{'5926'}~; }
	
	$startmember = ($inpage - 1) * $memberproseite;
	$endmember = $startmember + $memberproseite - 1;
	if ($endmember > (@memberarray-1)) { $endtopic = @memberarray - 1; }
}


### footer

$output .= qq~<p><table cellpadding=0 cellspacing=0 border=0 width=$tablewidth bgcolor=$tablebordercolor align=center>
<tr>
	<td>
	
	<table cellpadding=6 cellspacing=1 border=0 width=100%>
	<tr bgcolor=$menubackground>
		<td align=center><font face="$font" color=$fontcolormisc size=1>$pagelinks</font></td>
	</tr>
	</table>
	
	</td>
</tr>
</table>
<p align=center><font face="$font" color=$fontcolormisc size=1>
memberlist $memberlistversion by ronecker</font></p>
</center>
</body>
</html>~;

# You know the rules, leave the copyright intact and you'll get new versions in the future

if ($a ne "") { $output =~ s/option value=$a/option value=$a selected/; }

print header();
&output(
       -Title   => "$boardname - $ibtxt{'5901'}",
       -ToPrint => $output,
       -Version => $versionnumber
       );
